Page MenuHomePhabricator

Upload To Commons app: Make categorization easy/reliable
Closed, ResolvedPublic

Description

Upload To Commons is an app for Android users to conveniently upload pictures taken from their devices.
The app was created by Wikimedia, then abandoned for a while, and is now trying to resurface as a community-maintained effort.

The goal of the project is to let users easily add relevant categories to their pictures. The benefits are double:

  • App is easier/faster to use, less typing
  • Pictures are better categorized, which makes them findable and thus more re-usable
  • Guessing the appropriate categories for uncategorized pictures taken by other people is hard, time-wasting, and sometimes impossible. Time spent on this task will be saved.

This goal will be achieved by:

  • Showing nearby categories
  • Making category search "fuzzier"

Primary Mentor: @Niedzielski (Android expert developer, wikimedia-mobile member), Mountain Time Zone, UTC-06:00 through October 31, UTC-07:00 on November 1
Co-mentor: @Nicolas_Raoul (twice GSoC mentor, developer of AnkiDroid, active on Commons, current maintainer of Upload to Commons, GMT+9)
Estimated time for a senior contributor: 3 weeks
Skills needed:

  • Android development
  • Git usage
  • Wikimedia Commons usage, at least as a media contributor
  • Daily reporting

Microtask: https://github.com/nicolas-raoul/apps-android-commons/issues/11 (completed)

Phases of the project:

  1. Nearby categories:
    1. Identify the best strategy/APIs to find nearby categories
    2. Extract GPS coordinates from the picture
    3. Implement asynchronous calls to the APIs
    4. Show resulting categories
  2. "Fuzzy" category search
    1. Identify common patterns of category search near-misses
    2. Search for an API that would allow "fuzzy" search, and use it if available
    3. If not available, implement it by simple tricks like capitalization/pluralization

Related Objects

StatusAssignedTask
Resolvedjosephine_l
Resolvedjosephine_l
Resolvedjosephine_l
Resolvedjosephine_l
Resolvedjosephine_l
Resolvedjosephine_l
Resolvedjosephine_l
Resolvedjosephine_l
Resolvedjosephine_l
Resolvedjosephine_l
Resolvedjosephine_l
Resolvedjosephine_l
Resolvedjosephine_l
Resolvedjosephine_l
Resolvedjosephine_l
Resolvedjosephine_l
Resolvedjosephine_l
Resolvedjosephine_l
Resolvedjosephine_l
Resolvedjosephine_l
ResolvedNiedzielski
Resolvedjosephine_l
ResolvedNiedzielski
Resolvedjosephine_l
ResolvedNiedzielski

Event Timeline

Nicolas_Raoul assigned this task to josephine_l.
Nicolas_Raoul raised the priority of this task from to Normal.
Nicolas_Raoul updated the task description. (Show Details)
Nicolas_Raoul added a subscriber: Nicolas_Raoul.
Restricted Application added subscribers: Steinsplitter, Aklapper. · View Herald TranscriptOct 1 2015, 12:09 PM
Steinsplitter moved this task from Incoming to Backlog on the Commons board.Oct 4 2015, 11:52 AM
josephine_l added a comment.EditedOct 5 2015, 4:23 AM

I have been working on this project with @Nicolas_Raoul's guidance and have completed the microtask. However we are still lacking another mentor for the Outreachy application. Is there anyone who would be willing to help?

Qgil added a project: Mobile-Apps.EditedOct 5 2015, 7:31 AM
Qgil added a subscriber: Qgil.

I'm bringing this task to the attention of the Mobile-Apps team. Hopefully they have time to provide feedback about this proposal, and eventually volunteer a co-mentor.

An email to mobile-l linking to this proposal cannot harm. A post in Commons neither.

Thanks @Qgil. I'll email mobile-l, have already emailed commons-l.

Nicolas_Raoul renamed this task from Upload To Commons app: Suggest nearby categories to Upload To Commons app: Make categorization easy/reliable.Oct 5 2015, 9:37 AM
Nicolas_Raoul updated the task description. (Show Details)
Nicolas_Raoul set Security to None.
Nicolas_Raoul updated the task description. (Show Details)Oct 5 2015, 9:40 AM

I wonder whether this feature for categorizing Commons images could be developed in a way that it could also be eventually adapted for the Wikipedia app for Android. I'm aware that this is not a 1:1 mapping, but the problem and the potential ways to solve it are very similar. This would be an added incentive for the Mobile Apps team to get involved.

Mvolz added a subscriber: Mvolz.Oct 5 2015, 1:22 PM
Matanya added a subscriber: Matanya.Oct 5 2015, 5:00 PM

@Qgil from what I've read so far, the geolocation API could be used by either app. However the Wikipedia app does not appear to have an image upload functionality... and if such a functionality were written for it, what would become of the Upload to Commons app?

It's possible that I'm missing the point entirely though. Could @Nicolas_Raoul chime in?

I don't think Commons categorization source code can be directly re-used in the Wikipedia app, even though it might share some similarities, for instance the UI might look similar.

In future, if the Wikipedia app decides to include a Commons upload feature in their app, then they could easily reuse our source code, which is why open source is great :-)

I have created a subtask for discussing the workflow, deliverables and schedule related to this project. Any comments/suggestions there would be much appreciated.

saper added a subscriber: saper.Oct 12 2015, 9:27 PM

This is the last call for Possible-Tech-Projects missing mentors. The application deadline for Outreachy-Round-11 is 2015-11-02. If this proposal doesn't have two mentors assigned by the end of Thursday, October 22, it will be moved as a candidate for the next round.

Interested in mentoring? Check the documentation for possible mentors.

We have two mentors already I think, as @Niedzielski has volunteered to mentor alongside @Nicolas_Raoul. Which section should I move this to?

If I understand correctly we still need a primary mentor (I have always been listed as co-mentor by my choice).

@Niedzielski, would you consider beeing the primary mentor?

@Nicolas_Raoul, I'm happy to be a primary project mentor! In the interest of transparency, I will be following the guidelines[0] and withholding an official candidate decision until after the deadline but being proactive tends to lead to success :)

[0] https://www.mediawiki.org/wiki/Outreach_programs/Possible_mentors#Before

Thanks, @Niedzielski! :)

@01tonythomas should we be moving this out of the Possible-Tech-Projects missing mentors? Where should it go to?

01tonythomas updated the task description. (Show Details)Oct 20 2015, 3:41 AM
01tonythomas removed josephine_l as the assignee of this task.Oct 20 2015, 3:49 AM
01tonythomas added a subscriber: josephine_l.

Thank you @Niedzielski. I am setting this task up for grabs so that the task is open for potential candidates to submit a proposal :)

I am shifting this to Outreachy-Round-11 as the project description has two mentors, micro-tasks and looks ready for the 11th edition of Outreachy ( Dec 2015 - Mar 2016 ) . Potential candidates should start by submitting their proposals as a blocker for this task, by November 02.

Feel free to revert it back, if this task has some relevant issues which might block its completion in this term of Outreachy.

@01tonythomas I think I have set my proposal as a blocker for this task. Just confirming that I have done it correctly? Thanks. :)

Nicolas_Raoul updated the task description. (Show Details)
Nicolas_Raoul updated the task description. (Show Details)
Nicolas_Raoul removed a subscriber: josephine_l.
01tonythomas removed josephine_l as the assignee of this task.Oct 20 2015, 10:08 AM
01tonythomas added a subscriber: josephine_l.

Please note that mentors/co-mentors are not expected to assign a possible-project-task to potential candidates until the official announcement of program results. Please refer to : https://www.mediawiki.org/wiki/Outreach_programs/Possible_mentors#Before

Please keep the gate open for candidates till November-2, the official deadline of proposal submission!

Niedzielski updated the task description. (Show Details)Oct 20 2015, 2:09 PM
Matanya added a subscriber: Lester.Nov 26 2015, 9:04 PM
Restricted Application added a subscriber: Poyekhali. · View Herald TranscriptApr 25 2016, 12:15 PM

Closing this, if anyone disagrees please feel free to reopen.

josephine_l closed this task as Resolved.Nov 25 2016, 6:32 AM

Thanks @josephine_l. I assume the merit is yours? :)

Hi @Qgil , yes I completed this task during the Dec 2015 Outreachy round. :)